!> \file module_choix-greeneem.f90
!!  Ce module permet de choisir quels package on veut utiliser
! 
! Adapte a nouvelle version GRISLI C. DUMAS 04/2015
!
!

MODULE MODULE_CHOIX

!--------------Lecture topo ------------------------

use lect_topo_greeneem    ! pour le groenland NEEM 

!--------------Lecture climat ref ------------------

!version mensuelle :
!!!!!use lect_clim_act_greeneem_mois  ! version standard
!use lect_clim_act_greeneem_mois_lapsecouche ! attention a choisir climat perturb lapsecouche
!-------------------

!version annuelle
!use lect_clim_act_greeneem     ! temp parametree (GMINT) mais precip mar, attention a regarder massb_Tparam
!use lect_clim_act_greeneem_mar !precip, temp de mar mais annuel, attention a regarder massb_Tparam
!-------------------

!--------------Module climat ---------------
!use climat_forcage_mois_mod ! forcage mensuel GCM 1 Snapshot Fev 2015
!use climat_Grice2sea_years_mod ! forcage avec SMB type MAR Fev2015
!use climat_forcage_mois_mod ! climat mensuel GCM, possibilite d'utiliser plusieurs snapshots avec fichier d'evolution (Pas de correction topo)
!use climat_forcage_insolation_mod_oneway ! Methode JB 1 snaphot avec topo
use climat_forcage_insolation_mod ! Methode JB plusieurs snapshots avec topo + courbe insol + courbe co2

! Anciens modules pas encore valides
!!!!!!use climat_perturb_mod ! pour simule climat equilibre type Loveclim
!!!!!!use climat_forcage_stat_mois_mod  ! climat constant mensuel GCMs
!!!!!!use climat_forcage_mod ! pour cycle force GCM avec index
!!!!!!use climat_forcage_insolation_mod ! methode JB multi-snapshots mensuelle mais pour un etat stationnaire avec correction topo GCM => GRISLI
!!!!!!use climat_synthes_mod
!!!!!!use climat_profil_mod
!!!!!!use climat_regions_delta

use ablation_mod ! calcul de l'ablation (PDD ou autre methode)
!use no_ablation  ! pas de calcul de l'ablation => lecture fichier SMB (necessaire avec climat_Grice2sea_years_mod)

! pas de differences locales de niveau marin
use no_rsl

! suivi des traceurs ou pas ?
!use tracer_mod  ! probablement pas compatible avec Hemin-40 actuellement
use notracer_mod

!--------------Choix isostasie----------------------
use isostasie_mod  ! module permettant de calculer la deflexion isostasique
! use noisostasie_mod ! module pour ne pas avoir d'isostasie

!--------------Module Physique---------------------
use deformation_mod_2lois   ! module concernant les lois de deformation

! eau basale
use eau_basale

! sliding- dragging
! use module sliding_vitbal
use sliding_Bindschadler
! use sliding_dragging_heino    ! loi de glissement heino : mis dans diffusiv : 


!use dragging_vitbil
!use dragging_hwatstream
!use dragging_hwat_cont
!use dragging_hwat_contmaj          !version neem sans streams validee greeneem15
!use dragging_neem               ! neem avec streamsn,masque offline
use dragging_hwat_sedim          ! version C. Dumas


!------------ spinup -----------------------------------
use no_spinup           ! spinup=0
!use spinup_vitbil         ! plusieurs variantes de spinup : inclue le dragging
                          ! enlever le use dragging dans ce cas l

! use eq_elliptique_mod ! ancienne version (remplimat-5)
use eq_ellip_sgbsv_mod ! nouvelle version juillet 2008

! calving
use calving_frange

! choix resolution de la conservation de la masse
!-----------------------------------------------
!use equat_adv_diff_2D          ! conservation masse avec advection-diffusion
use equat_adv_diff_2D_vect      ! le vecteur est maintenant dans l'appel

!--------------Fusion basale------------------------
use bmelt_seuil_prof
! use bmelt_ant_regions ! pour l'Antarctique avec rgions
! USE BMELT_NOR_REGIONS ! pour le nord avec rgions
! use BMELT_NOR_DEPTH   ! pour le nord avec profondeur d'eau


! fake -------fausses routines pour compatibilits
! use fake_heino
! use fake_ant
use fake_greeneem

! use fake_nord
!-------------- Outputs-----------------------------
!
use out_profile  !profils

!-----Suivi temporel
 use output_greeneem_mod

!-----debugage...
use printtable


end module module_choix
