!> \file paradim-hemin15_mod.f90
!! Def des dimensions du grille hemin 15 km  
!<

!> \namespace module_nord
!! Def des dimensions du grille hemin a 15 km  
!! \author C. Dumas
!! \date 15/05/2015
!<


module module_hemin15
  
  implicit none

  character(len=7), parameter :: geoplace='hemin15'    ! geoplace
  character(len=17), parameter  :: dirnameinp='../INPUT/HEMIN15/' ! input directory
  character(len=17), parameter  :: dirforcage='../INPUT/Forcage/' ! input directory

! dimensionnement grilles
!-------------------------
  integer, parameter :: nx=642           !< dimension selon x (indice i)
  integer, parameter :: ny=642           !< dimension selon y (indice j)
  integer, parameter :: nlmin=141        !< min(nx,ny), pour matrice elliptique  
  integer, parameter :: nz=21            !< dimension selon z (indice k) 
  integer, parameter :: nzm=4            !< nb de points verticaux dans le socle
  integer, parameter :: nn=241           !< pour des sorties
!cdc integer, parameter :: nx1=nx-1,ny1=ny-1,nz1=nz-1


! pas horizontal
!-----------------
  real, parameter :: dx=15000.0             !< pas en X en m
  real, parameter :: dy=15000.0             !< pas en Y en m


end module module_hemin15
