module sliding_hudson

! Dfini la loi de glissement dans les expriences Heino
! modification par rapport a la version de Catherine : ice-shelves + streams autorises

  USE module3D_phy
  USE sedim_declar

  implicit none

  real :: Cr                            ! coefficient glissement pour hard rock
  real :: Cs                            ! coefficient glissement pour sediment
  real :: coefmax
  real :: coefslid
  real :: coefdrag
!logical,dimension(nx,ny) :: gzmx_heino     ! pour transporter la valeur dans flottab
!logical,dimension(nx,ny) :: gzmy_heino
  real :: longslope
  real :: seuil_gliss                   ! seuil sur hw_mx pour avoir du glissement
  real, dimension(nx,ny) :: hw_mx
  real, dimension(nx,ny) :: hw_my

!character(len=80) :: filin


contains
!-------------------------------------------------------------------------------
  subroutine init_sliding

! formats pour les ecritures dans 42
428 format(A)

    namelist/sliding_Heino/seuil_gliss,coefmax,Cr,Cs   
! lecture des parametres du run                      block sliding_heino
!--------------------------------------------------------------------

    rewind(num_param)        ! pour revenir au debut du fichier param_list.dat
    read(num_param,sliding_Heino)

    write(num_rep_42,428)'!___________________________________________________________' 
    write(num_rep_42,428) '&sliding_Heino                  ! nom du bloc sliding Heino'
    write(num_rep_42,*)
    write(num_rep_42,*) 'seuil_gliss    = ', seuil_gliss 
    write(num_rep_42,*) 'coefmax        = ', coefmax
    write(num_rep_42,*) 'Cr             = ', Cr
    write(num_rep_42,*) 'Cs             = ', Cs
    write(num_rep_42,*)'/'                            
    write(num_rep_42,428) '! seuil_gliss (m) : glissement si eau basale des 6 voisins > seuil_gliss'
    write(num_rep_42,428) '! coefmax : hauteur d eau max dans le sediment (=hwatermax)'
    write(num_rep_42,428) '! Cr : coeficient glissemnt sur hard rock (loi en puissance 3)'
    write(num_rep_42,428) '! Cs : coefficient de la loi de frottement sediment (loi lineaire)'
    write(num_rep_42,*)

!cdc if (itracebug.eq.1)  call tracebug(' Heino: entree dans routine init_sliding')

! Cette routine fait l'initialisation du glissement et est appele juste apres
! la lecture du masque

! Cette routine fait l'initialisation du glissement

!loigliss=4       ! 4 -> que glissement Heino (pas de mode dragging)
!if (loigliss.eq.4) then
!   flgzmx(:,:)=.false.
!   flgzmy(:,:)=.false.
!endif
!    coefmax=hwatermax
!    seuil_gliss=0.0001
                      ! 5 -> glissement Heino + dragging

!    ecriture dans le fichier parametres
    write(42,*)
    write(42,*)'glissement Heino -  initialisation masque'
!    write(42,*)'loi glissement=',loigliss
!     write(num_rep_42,*)'coef=1, gliss si les 2 voisins temperes' 
    write(42,*)'glissement si eau basale (6 voisins) >=seuil_gliss=',seuil_gliss
    write(42,*)'coef dependant de la hauteur d eau    coefmax=',coefmax
    write(42,*)' moyenne de la hauteur d eau a partir de 6 voisins'
    write(42,*)'----------------------------------------------------------'


! fichier mask fourni par l'intercomparaison Heino 
! on refait la lecture 

!      filin='mask-shelf-40.dat'

!      filin = TRIM(DIRNAMEINP)//TRIM(filin)

!       write(42,*) 'type de socle '
!       write(42,*) 'mksedim donne par ',filin

!open(11,file=filin)
!do i=1,6
!      read(11,*)  ! 6 lignes de commentaires
!end do


! lecture proprement dite de la carte sediment
!do j=ny, 1, -1
!    read(11,'(87i1)') (mksedim(i,j), i=1,nx)
!end do


!close(11)


! test pour une calotte axi-symetrique avec glissement Cr partout
!write(num_rep_42,*) 'masque sediment mis a 1 '
!mksedim(:,:)=min(mksedim(:,:),1)

! a la frontiere le demi noeud est sediment.
! calcul du masque sur les demi mailles : frontiere -> sedim
!mkxsedim(:,:)=max(mksedim(:,:),eoshift(mksedim(:,:),shift=-1,boundary=0,dim=1))
!mkysedim(:,:)=max(mksedim(:,:),eoshift(mksedim(:,:),shift=-1,boundary=0,dim=2))
! write(42,*) 'sur les bords zone sediment, masque exterieur '


!mkxsedim(:,:)=min(mksedim(:,:),eoshift(mksedim(:,:),shift=-1,boundary=0,dim=1))
!mkysedim(:,:)=min(mksedim(:,:),eoshift(mksedim(:,:),shift=-1,boundary=0,dim=2))

!write(num_rep_42,*) 'sur les bords zone sediment, demi-maille sediment si les 2 mailles le sont'

    mslid_mx(:,:)=mkxsedim(:,:)
    mslid_my(:,:)=mkysedim(:,:)

!    Cr=1.e5    ! en a-1  coefficient hard rock (loi en puissance 3)
!    Cs=500.    ! en a-1  coefficient sediment (lineaire)


    write(42,*)'coefficients:   Cr=',Cr,'    Cs=',Cs,' (a-1)'
!  write(num_rep_42,*)'glissement seulement si les 2 voisins sont au point de fusion'



    return
  end subroutine init_sliding


  subroutine sliding


! cette routine calcule le terme ddbx et ddby dans le cas Heino
!      -------------------------------------------------
!      GLISSEMENT
!      DDBX et DDBY termes dus au glissement 
!      relation avec la vitesse de glissement UXB et UYB 
!      UXB=-DDBX*SDX et UYB=-DDBY*SDY
!      -------------------------------------------------

    implicit none

    integer :: i_moins1,j_moins1,i_plus1,j_plus1

!!$real, dimension(nx,ny) :: hw_mx
!!$real, dimension(nx,ny) :: hw_my

!cdc if (itracebug.eq.1)  call tracebug(' Heino: entree dans routine sliding')


    call moy_mxmy(nx,ny,Hwater,hw_mx,hw_my)



    slidy: do j=1,NY
       do I=1,NX

          pose_y:  if (.not.flgzmy(i,j)) then

             if (HMY(I,J).lt.1.) then        ! glace tres fine
                ddby(i,j)=0.
                mslid_my(i,j)=0

!   else if ((T(i,j,nz).lt.Tpmp(i,j,nz)).and.(T(i,j-1,nz).lt.Tpmp(i,j-1,nz))) then 
!      ddby(i,j)=0.                 ! pas de glissement seulement
!                                   ! si les 2 voisins sont froids

!   else if ((T(i,j,nz).lt.Tpmp(i,j,nz)).or.(T(i,j-1,nz).lt.Tpmp(i,j-1,nz))) then 

!      else if ((ibase(i,j).eq.1).or.(ibase(i,j-1).eq.1)) then
!      else if ((ibase(i,j).eq.1).and.(ibase(i,j-1).eq.1)) then

             else if (hw_my(i,j).lt.seuil_gliss) then
                ddby(i,j)=0.                 ! pas de glissement si tous les voisins 
                                   ! sont a sec
                mslid_my(i,j)=0
!      flgzmy(i,j)=.false. ! on ne bloque pas les ice-shelves

             else                            ! glissement
!      coefslid=(hwater(i,j)+hwater(i,j-1))*0.5
                coefslid=hw_my(i,j)
                coefslid=max(coefslid,0.)
                coefslid=min(coefslid/coefmax,1.)
!      coefslid=1.


!jalv le mksedim maintenant dans hudson: mksedim=0 ==> hard rock (=1 ==> ocean)
!                if (mkysedim(i,j).eq.1) then  ! loi hard rock
!                if (mkysedim(i,j).eq.0) then  ! loi hard rock

!jalv: pas besoin de if mksedim... si l'on enleve le sliding de type Calov 
! (y a pas besoin de specifier dans quel type de sediments on est)
!                if ((mkysedim(i,j).eq.0).or.(mkysedim(i,j).eq.2)) then  ! loi hard rock
                ddby(i,j)=Cr*slope2my(i,j)*Hmy(i,j)*coefslid          ! loi hard rock


                mslid_my(i,j)=1

 
!jalv:si on met en comentaire les lignes suivantes: 
!     test pas de sliding de type Calov dans la zone sediment 
!     (sliding normal avec la dependence en Cr et non en Cs)

!               else if ((mkysedim(i,j).eq.2)) then  ! loi sediment
!                   ddby(i,j)=Cs*Hmy(i,j)*coefslid

!                   mslid_my(i,j)=2

!jalv: test longslope

!         if (abs(sdy(i,j)).gt.1.e-8) then
!            j_1=max(j-1,1)
!            j1=min(j+1,ny)
!            longslope=(sdy(i,j_1)+sdy(i,j)+sdy(i,j1))/3.
!            ddby(i,j)=ddby(i,j)/sdy(i,j)*longslope
!         endif

!jalv: pas besoin maintenant si c'est bien fait
!                else
!                   ddby(i,j)=0.
!                   mslid_my(i,j)=0

!                endif
             endif

          endif pose_y
       end do
    end do slidy


    slidx: do j=1,NY
       do i=1,NY
          pose_x:  if (.not.flgzmx(i,j)) then

             if (HMX(I,J).lt.1.) then        ! glace tres fine
                ddbx(i,j)=0.
                mslid_mx(i,j)=0

!   else if ((T(i,j,nz).lt.Tpmp(i,j,nz)).and.(T(i-1,j,nz).lt.Tpmp(i-1,j,nz))) then 
!      ddbx(i,j)=0.                 ! pas de glissement seulement
!                                   ! si les 2 voisins sont froids

!   else if ((T(i,j,nz).lt.Tpmp(i,j,nz)).or.(T(i-1,j,nz).lt.Tpmp(i-1,j,nz))) then 
!     else if ((ibase(i,j).eq.1).or.(ibase(i-1,j).eq.1)) then

!      else if ((ibase(i,j).eq.1).and.(ibase(i-1,j).eq.1)) then
             else if (hw_mx(i,j).lt.seuil_gliss) then
                
                ddbx(i,j)=0.                 ! pas de glissement si au moins un seul 
                                   ! des 2 voisins est froid
                mslid_mx(i,j)=0
!      flgzmx(i,j)=.false. ! on ne bloque pas les ice-shelves


             else                            ! glissement

!      coefslid=(hwater(i,j)+hwater(i-1,j))*0.5
                coefslid=hw_mx(i,j)
                coefslid=max(coefslid,0.)
                coefslid=min(coefslid/coefmax,1.)
!      coefslid=1.

!jalv le mksedim maintenant dans hudson: mksedim=0 ==> hard rock (=1 ==> ocean)
!                if (mkxsedim(i,j).eq.0) then  ! loi hard rock

!jalv: pas besoin de if mksedim... si l'on enleve le sliding de type Calov 
! (y a pas besoin de specifier dans quel type de sediments on est)
!                if ((mkxsedim(i,j).eq.0).or.(mkysedim(i,j).eq.2)) then  ! loi hard rock
                ddbx(i,j)=Cr*slope2mx(i,j)*Hmx(i,j)*coefslid
                mslid_mx(i,j)=1


!jalv: si on met en comentaire les lignes suivantes:
!      test pas de sliding de type Calov dans la zone sediment 
!      (sliding normal avec la dependence en Cr et non en Cs)
!                else if ((mkxsedim(i,j).eq.2)) then  ! loi sediment
!                   ddbx(i,j)=Cs*Hmx(i,j)*coefslid
!                   mslid_mx(i,j)=2

!jalv: test longslope

!         if (abs(sdx(i,j)).gt.1.e-8) then
!            i_1=max(i-1,1)
!            i1=min(i+1,nx)
!            longslope=(sdx(i_1,j)+sdx(i,j)+sdx(i1,j))/3.
!            ddbx(i,j)=ddbx(i,j)/sdx(i,j)*longslope
!         endif

!jalv: pas besoin maintenant si c'est bien fait
!                else
!                   ddbx(i,j)=0.
!                   mslid_mx(i,j)=0

!                endif
             endif

          endif pose_x
       end do
    end do slidx

    return
  end subroutine  sliding


END MODULE sliding_hudson


