!> \file accum7.f
!! Calcule de l'accumulation  
!<

!> SUBROUTINE: Accum7
!! Calcul l'accumulation de glace anuelle 
!! \author Catherine 
!! \date   Avril 99
!! @note Accumulation heminord pour la deglaciation 
!! @note Used modules:
!! @note    - use module3D_phy
!! @note    - use climat_forcage_mod
!!
!<

      subroutine ACCUM7()

! --------------------------------------------------------------------
!      Accumulation heminord pour la deglaciation 
!        
!                                                 Catherine Avril 99
!---------------------------------------------------------------------

      USE module3D_phy
      USE CLIMAT_FORCAGE_MOD
!      USE CLIMAT_PROFIL_MOD

      implicit none
      real SLMIN


!     calcul de Tjuly et et Tann

      do J=1,NY
        do I=1,NX
           ZS(I,J)=max(SEALEVEL,S(I,J))

           Tann(i,j)= - TEMPGRAD * (Zs(i,j)-S0(i,j))   ! correction d'altitude
     &                + delTatime(i,j)+TA0(I,J)
            
           Tjuly(i,j)=- TEMPGRJUL * (Zs(i,j)-S0(i,j))   ! correction d'altitude
     &                + delTjtime(i,j)+TJ0(I,J)
        end do
      end do



c     ******* temperature et duree de l'hiver *****
      PYY=2.*PI/50.
      do J=1,NY
       do I=1,NX
        FT(I,J)=0.
        do K=1,50
          TEMP=TANN(I,J)-(TJULY(I,J)-TANN(I,J))*cos(PYY*K) 
          if (TEMP.le.PSOLID) then
            FT(I,J)=FT(I,J)+1.
          end if
        end do
        FT(I,J)=FT(I,J)/50.
       end do
      end do

c   ------------- Precipitation ------------------------------
c   fonction de exp(0.05 T)
      do J=1,NY
       do I=1,NX

           Precip(i,j)=precip0(i,j)*rapactime(i,j)*
     &                  exp(0.05*(Tann(i,j)-Ta0(i,j)))

c           Precip(i,j)=precip0(i,j)*rapactime(i,j)

           ACC(I,J)=PRECIP(I,J)*FT(i,j)

       end do
      end do



      end
