module declar_map_recul

implicit none
integer, parameter :: nx = 387
integer, parameter :: ny = 374 
integer            :: i,j                         ! pour les boucles

! donnees d'entree
real,dimension(nx,ny)              :: H0          !< epaisseur
real,dimension(nx,ny)              :: H           !< courant
real,dimension(nx,ny)              :: Bsoc        !< socle
real,dimension(nx,ny)              :: B           !< base
real,dimension(nx,ny)              :: S           !< surface
real,dimension(nx)                 :: X_15        !< dimension X
real,dimension(ny)                 :: Y_15        !< dimension Y

! utilise dans les calculs  
real,dimension(nx,ny)              :: delHdt_mx   !< variation d'epaisseur imposee venant de x
real,dimension(nx,ny)              :: delHdt_my   !< variation d'epaisseur imposee venant de y
real,dimension(nx,ny)              :: delHdt      !< variation d'epaisseur imposee venant de y
real,dimension(nx,ny)              :: H_float     !< epaisseur de flottaison
real,dimension(nx,ny)              :: time_float  !< temps auquel le noeud se met a flotter
real,dimension(nx,ny)              :: Deltatot_H0 !< variation d'epaisseur totale au moment ou le noeud
                                                  !< commence a decroitre

real,dimension(4)                  :: dH_voisin   ! quand on balaye les voisins

real,dimension(nx,ny)              :: time_dep_mx !< temps a partir duquel le recul est autorise (noeuds >)
real,dimension(nx,ny)              :: time_dep_my !< temps a partir duquel le recul est autorise (noeuds ^)

real,dimension(nx,ny)              :: x_gl_mx     !< position sous maille de la grounding line selon x
real,dimension(nx,ny)              :: y_gl_my     !< position sous maille de la grounding line selon y    
                                                  !< sur les mailles mineures                             
                            
integer,dimension(nx,ny)           :: mk_traiter  !< masque des noeuds a traiter
integer,dimension(nx,ny)           :: mk_gr       !< masque des noeuds flottants
integer,dimension(nx,ny)           :: newfloat    !< masque des noeuds qui viennent de flotter
integer,dimension(nx,ny)           :: i_delta     !< index qui dit si un noeud est en cours de decroissance

real,dimension(nx,ny)              :: retreat0_x  !< vitesse maxi autorisee selon x : valeur initiale
real,dimension(nx,ny)              :: retreat0_y  !< vitesse maxi autorisee selon y : valeur initiale
real,dimension(nx,ny)              :: retreat_x   !< vitesse maxi autorisee selon x 
real,dimension(nx,ny)              :: retreat_y   !< surface maxi autorisee selon y 



real                              :: dx           !< pas d'espace
real                              :: dt           !< pas de temps
real                              :: time         !< temps
real                              :: retreat_rate !< taux de retrait
real                              :: coef_Bflot   !< pour ice shelves B = coef_Bflot * H
integer                           :: som_voisins  !< pour des tests
integer                           :: i_time       !< pour boucle temps
integer                           :: n_time       !< pour boucle temps




! pour les io netcdf
!-------------------------

integer                            :: ncid           ! numero d'unite
integer                            :: status         !< operations io netcdf 
character(len=100)                 :: file_ncdf      !< fichier netcdf
character(len=100)                 :: fileout_ncdf   !< fichier netcdf
character(len=20),dimension(2)     :: dimname        ! pour les noms de dimension
Character*20,dimension(:),pointer  :: tabvarname     ! pour les noms de variable
real*8, dimension(:,:),   pointer  :: work_tab       !< tableau 2d real ecrit dans le fichier 
real*8,dimension(:),pointer        :: Tabx           ! pointeur vers le tableau des x
real*8,dimension(:),pointer        :: Taby           ! pointeur vers le tableau des y

end module declar_map_recul
